# RequestEncoder

This folder contains definition of RequestEncoder. The RequestEncoder is what is used to create the string that will be signed for integrity check. Any data no in the RequestEncoder generated string may be altered without you knowing at signature check. If you add data such as timestamp as recommanded, you need to include it in your signed data.

The folder contains a first RequestEncoder using go template to generate the signature string. Here is an example go template you may use (see it working in the `test` folder):

```go text/template
host:{{.Req.Host}}
path:{{.Req.URL.Path}}
rawQuery:{{.Req.URL.RawQuery}}
method:{{.Req.Method}}
body:{{md5 .Body | b64}}
{{range $key, $value := .Req.Header -}}
    {{- if inSlice $key $.UserData.HeaderToSign -}}
        {{- range $value -}}
            {{- $key -}}={{- . -}};
        {{- end -}}
    {{- end -}}
{{- end}}
```

This template will add one line per information:
- the host
- the path
- the query-string
- the method
- the base65 of a md5 hash of the body
- headers provided by the user in the `UserData.HeaderToSign` field

Note that go template sort map when able to do so, using the template twice with the same dataset will always giveout the same result.
